# Kvalifika Flutter SDK

## Table of Contents

- [Flutter Development Environment](#installation)
- [Development Workflow](#development-workflow)
- [Versioning SDK](#versioning-sdk)
- [Flutter Sample](#flutter-sample)
- [Updating Android and iOS SDK Versions](#updating-android-and-ios-sdk-versions)
- [Publishing SDK](#publishing-sdk)

&nbsp;

## Flutter Development Environment

[Set Up Environment](https://flutter.dev/docs/get-started/install)

Install Visual Studio Code and Flutter and Dart extensions

&nbsp;

## Development Workflow

There are following folders:

- lib - which includes SDK code
- example - Sample Flutter app that uses SDK directly

To start an example application, open `main.dart` file.

Click `Run icon` and then `Start Debugging`
Make sure to use physical device for testing.

If device is Android, enable Developer Options in device settings.

&nbsp;

## Versioning SDK

We use [Semver](https://semver.org/) for versioning an SDK

&nbsp;
## Flutter Sample
[Kvalifika Flutter Sample](https://github.com/Kvalifika/kvalifika-flutter-sample) is repository which installs and uses `Kvalifika Flutter SDK` from `pub.dev`

This is public repository where we write a technical documentation about integrating an SDK in iOS projects.

After releasing new SDK version. You can test it in a separate project.

&nbsp;

## Updating Android and iOS SDK Versions
`kvalifika_sdk.dart` is main file which calls native layer to initialize and start session.

`SwiftKvalifikaSdkPlugin.swift` handles initialization for iOS.

`KvalifikaSdkPlugin.kt` handles initialization for Android

To update Android SDK version:
1. Open `build.gradle` file
2. In `dependencies` update version like `implementation 'com.kvalifika:sdk:0.8.0'`

To update iOS SDK version
1. Open `kvalifika_sdk.podspec` file
2. Update version matching `pubspec.yaml` version
2. Update `s.dependency Kvalifika` version

Last step:
1. Update version in `pubspec.yaml`. See [Versioning SDK](#versioning-sdk)

&nbsp;

## Publishing SDK

We publish our package to [Pub.Dev](https://pub.dev/)

1. Update `CHANGELOG.md`
2. Create Release on [GitHub](https://github.com/Kvalifika/kvalifika-flutter-sdk/releases/new)
3. Run `dart pub publish --dry-run` to see what will be published.
4. Run `dart pub publish` after you're ready to publish.
